#include "hmg.ch"
#include "hbclass.ch"

MEMVAR _HMG_SYSDATA

/*..................................................................................
 main function program entry
 *..................................................................................*/
FUNCTION main()

   SET( _SET_EPOCH, 2000 )
   SET CENTURY ON
   SET( _SET_DATEFORMAT, "dd-mm-yyyy" )

   p000_FrmDefine()

RETURN NIL

/*..................................................................................
 mainForm define function
 *..................................................................................*/
STATIC FUNCTION p000_FrmDefine()

   SET NAVIGATION EXTENDED
   DEFINE WINDOW p000win ;
      ROW 0 ;
      COL 0 ;
      WIDTH 860 ;
      HEIGHT 645 ;
      WINDOWTYPE MAIN ;
      TITLE "Main form" ;
      ON INIT p000_OnInit() ;
      FONTNAME "Arial" FONTSIZE 10

      DEFINE MAIN MENU
         DEFINE POPUP "&File"
            MENUITEM "e&Xit" ACTION p000_Exit()
         END POPUP
         DEFINE POPUP "&Samples"
            MENUITEM "&1 sample" ACTION Sample_1()
            MENUITEM "&2 sample" ACTION Sample_2()
            MENUITEM "&3 sample" ACTION Sample_3()
            MENUITEM "&4 sample" ACTION Sample_4()
            MENUITEM "&5 sample" ACTION Sample_5()
         END POPUP
      END MENU

   END WINDOW

   p000win.Activate

RETURN NIL

/*..................................................................................
 OnInit
 *..................................................................................*/
STATIC FUNCTION p000_OnInit()

   p000win.Center

RETURN NIL

/*..................................................................................
 exit
 *..................................................................................*/
STATIC FUNCTION p000_Exit()

   RELEASEALLWINDOWS()

RETURN NIL

/*..................................................................................
 Sample_1: adding simple value
 *..................................................................................*/
STATIC FUNCTION Sample_1()

   LOCAL oLetName := L3WBASEOBJ():New()

   MsgStop( "At startup oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddValue( "MyName" )
   MsgStop( "'MyName' property ADDED to oLetName " + hb_Eol() + "'MyName' value is " + hb_ValToExp( oLetName:MyName ) )

   oLetName:MyName := "Luigi"
   MsgStop( "Change value of 'MyName' to " + oLetName:MyName )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:Remove( "MyName" )
   MsgStop( "'MyName' property REMOVED from oLetName " + hb_Eol() + "'MyName' value is " + hb_ValToExp( oLetName:MyName ) )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddValue( "MyName", "Luigi" )
   MsgStop( "'MyName' property ADDED to oLetName " + hb_Eol() + "'MyName' value is " + oLetName:MyName )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:Remove( "MyName" )
   MsgStop( "'MyName' property REMOVED from oLetName " + hb_Eol() + "'MyName' value is " + hb_ValToExp( oLetName:MyName ) )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

RETURN NIL

/*..................................................................................
 Sample_2: adding more values
 *..................................................................................*/
STATIC FUNCTION Sample_2()

   LOCAL oLetName := L3WBASEOBJ():New()

   MsgStop( "At startup oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddValue( "MyName", "Luigi" )
   oLetName:AddValue( "MyAge", 47 )
   oLetName:AddValue( "MyBornDate", CTOD( "31-01-1964" ) )

   MsgStop( "'MyName' property ADDED to oLetName " + hb_Eol() + "'MyName' value is " + oLetName:MyName )
   MsgStop( "'MyAge' property ADDED to oLetName " + hb_Eol() + "'MyAge' value is " + hb_NtoS( oLetName:MyAge ) )
   MsgStop( "'MyBornDate' property ADDED to oLetName " + hb_Eol() + "'MyBornDate' value is " + DTOC( oLetName:MyBornDate ) )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:Remove()
   MsgStop( "REMOVED all from oLetName " )
   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )


RETURN NIL

/*..................................................................................
 Sample_3: adding simple section
 *..................................................................................*/
STATIC FUNCTION Sample_3()

   LOCAL oLetName := L3WBASEOBJ():New()

   MsgStop( "At startup oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddSection( "Section1" )
   MsgStop( "'Section1' section ADDED to oLetName " + hb_Eol() + "'Section1' is an " + hb_ValToExp( oLetName:Section1 ) )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:Remove( "Section1" )
   MsgStop( "'Section1' section REMOVED from oLetName " + hb_Eol() + "'Section1' value is " + hb_ValToExp( oLetName:Section1 ) )

   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

RETURN NIL

/*..................................................................................
 Sample_4: adding more section and nested
 *..................................................................................*/
STATIC FUNCTION Sample_4()

   LOCAL oLetName := L3WBASEOBJ():New()

   MsgStop( "At startup oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddSection( "Section1" )
   oLetName:AddSection( "Section2" )
   oLetName:AddSection( "Section3" )

   MsgStop( "ADDED " + Hb_NtoS( oLetName:ItemCount() ) + " sections to oLetName " )

// nested
   oLetName:Section2:AddSection( "Sub21" )
   oLetName:Section2:AddSection( "Sub22" )
   oLetName:Section1:AddSection( "Sub11" )

   MsgStop( "ADDED " + Hb_NtoS( oLetName:Section2:ItemCount() ) + " to Section2 " )
   MsgStop( "ADDED " + Hb_NtoS( oLetName:Section1:ItemCount() ) + " to Section1 " )

   oLetName:Remove( "Section2" )
   MsgStop( "'Section2' removed " + hb_Eol() + "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:Remove()
   MsgStop( "REMOVED all from oLetName " )
   MsgStop( "oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

RETURN NIL

/*..................................................................................
 Sample_5: practical
 *..................................................................................*/
STATIC FUNCTION Sample_5()

   LOCAL oLetName := L3WBASEOBJ():New()

   MsgStop( "At startup oLetName ItemCount is equal to " + Hb_NtoS( oLetName:ItemCount() ) )

   oLetName:AddSection( "ProJect" )
   oLetName:ProJect:AddValue( "Title", "This is the project Title" )
   oLetName:ProJect:AddValue( "Version", "1.1" )
   oLetName:ProJect:AddValue( "Date", DATE() )

   oLetName:AddSection( "Forms" )
   oLetName:Forms:AddValue( "FontName", "Helvetica" )
   oLetName:Forms:AddValue( "FontSize", 12 )

   oLetName:AddSection( "Buttons" )
   oLetName:Buttons:AddValue( "FontName", "Arial" )
   oLetName:Buttons:AddValue( "FontSize", 8 )

   oLetName:Buttons:AddSection( "Bt_Click" )
   oLetName:Buttons:Bt_Click:AddValue( "Caption", "Click" )
   oLetName:Buttons:Bt_Click:AddValue( "ToolTip", "Click here to..." )
   oLetName:Buttons:Bt_Click:AddValue( "Image", "click.png" )

   oLetName:Buttons:AddSection( "Bt_Save" )
   oLetName:Buttons:Bt_Save:AddValue( "Caption", "Save" )
   oLetName:Buttons:Bt_Save:AddValue( "ToolTip", "Click here to Save" )
   oLetName:Buttons:Bt_Save:AddValue( "Image", "save.png" )

   DEFINE WINDOW wModal ;
      ROW 0 ;
      COL 0 ;
      WIDTH 320 ;
      HEIGHT 240 ;
      TITLE oLetName:ProJect:Title ;
      WINDOWTYPE MODAL ;
      FONT oLetName:Forms:FontName SIZE oLetName:Forms:FontSize

      DEFINE BUTTON Bt_Click
         ROW     40
         COL     10
         WIDTH   100
         HEIGHT  25
         CAPTION oLetName:Buttons:Bt_Click:Caption
         ACTION  MsgInfo('Clicked!')
         TOOLTIP oLetName:Buttons:Bt_Click:ToolTip
      END BUTTON

      DEFINE BUTTON Bt_Save
         ROW     140
         COL     110
         WIDTH   100
         HEIGHT  25
         CAPTION oLetName:Buttons:Bt_Save:Caption
         ACTION  MsgInfo('Clicked!')
         TOOLTIP oLetName:Buttons:Bt_Save:ToolTip
         FONTNAME oLetName:Buttons:FontName
         FONTSIZE oLetName:Buttons:FontSize
      END BUTTON

   END WINDOW

   wModal.Center
   wModal.Activate

RETURN NIL

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>> class <<<<<<<<<<<<<<<<<<<<<<<<<<<< */
/*================================================================
 L3WBASEOBJ class
 ================================================================*/
CLASS L3WBASEOBJ

// internal data
   DATA aControls                                 INIT {}   PROTECTED

// methods
   METHOD New
   METHOD AddObject
   METHOD AddSection
   METHOD AddValue
   METHOD IsDefined
   METHOD Remove

// Properties
   METHOD ItemList                                INLINE ::aControls
   METHOD ItemCount                               INLINE LEN( ::aControls )

// event

ENDCLASS

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 New: create a new object
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:New()

RETURN Self

/*---------------------------------------------------------------
 AddObject: add an object to its parent. Parent, in this moment, is Self
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:AddObject( cObjName, oObject )

   cObjName := ALLTRIM( cObjName )

   IF PCOUNT() == 2 .AND. hb_IsObject( oObject ) == .T.
      IF ::IsDefined( cObjName ) == .F.
         __objAddData( Self , cObjName )
         AADD( ::aControls, UPPER( cObjName ) )
      ENDIF
      ::&cObjName := oObject
   ENDIF

RETURN NIL

/*---------------------------------------------------------------
 AddSection
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:AddSection( cSectionName )

   LOCAL oNewObj, lAdded := .F.

   IF PCOUNT() == 1 .AND. hb_IsChar( cSectionName ) == .T.
      cSectionName := ALLTRIM( cSectionName )
      IF ::IsDefined( cSectionName ) == .F.
         __objAddData( Self , cSectionName )
         AADD( ::aControls, UPPER( cSectionName ) )
         oNewObj := L3WBASEOBJ():New()
         ::&cSectionName := oNewObj
         lAdded := .T.
      ENDIF
   ENDIF

RETURN lAdded

/*---------------------------------------------------------------
 AddValue
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:AddValue( cValueName, xValue )

   LOCAL lAdded := .F.

   IF PCOUNT() >= 1 .AND. hb_IsChar( cValueName ) == .T.
      cValueName := ALLTRIM( cValueName )
      IF ::IsDefined( cValueName ) == .F.
         __objAddData( Self , cValueName )
         AADD( ::aControls, UPPER( cValueName ) )
         ::&cValueName := IF( PCOUNT() == 2, xValue, NIL )
         lAdded := .T.
      ELSEIF PCOUNT() == 2
         ::&cValueName := xValue
         lAdded := .T.
      ENDIF
   ENDIF

RETURN lAdded

/*---------------------------------------------------------------
 IsDefined: check if cObjName is already defined
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:IsDefined( cObjName )

   LOCAL lDefined, nPos

   IF PCOUNT() == 1 .AND. hb_IsChar( cObjName) == .T.
      cObjName := UPPER( ALLTRIM( cObjName ) )
      nPos := ASCAN( ::aControls, cObjName )
      lDefined := IF( nPos == 0, .F., .T. )
   ELSE
      lDefined := .F.
   ENDIF

RETURN lDefined

/*---------------------------------------------------------------
 Remove
 ---------------------------------------------------------------*/
METHOD L3WBASEOBJ:Remove( cName )

   LOCAL nX, cObjName

   IF PCOUNT() == 0
      FOR nX := 1 TO LEN( ::aControls )
         cObjName := ::aControls[nX]
         IF hb_IsObject( Self:&cObjName )
            IF __objHasMethod( Self:&cObjName, "Remove" ) == .T.
               Self:&cObjName:Remove()
            ENDIF
         ENDIF
//   __objDelData( Self, cObjName ) I don't know why we can't use this Harbour founction without damages
         Self:&cObjName := NIL
      NEXT nX
      ::aControls := {}
   ELSE
      IF ::IsDefined( cName )
         IF hb_IsObject( Self:&cName )
            IF __objHasMethod( Self:&cName, "Remove" ) == .T.
               Self:&cName:Remove()
            ENDIF
         ENDIF
         nX := ASCAN( ::aControls, UPPER( ALLTRIM( cName ) ) )
         cObjName := ::aControls[nX]
         ::aControls := hb_Adel( ::aControls, nX, .T. )
//   __objDelData( Self, cObjName ) I don't know why we can't use this Harbour founction without damages
         Self:&cObjName := NIL
      ENDIF
   ENDIF

RETURN NIL
